      PROGRAM coord4lnc
C
C  * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
C  *  PROGRAM COORD4lnc: CALCULATES NODE POINT COORDINATES for   *
C  *  [0/90/-45/+45]s Gr/Ep laminate with No Crack, ASTM 1982    *
c  *                                                             *
c  *  Comment-out line "IF((V.GT.0.5).AND.(V.LT.1.0))IQ=0" if    *
c  *  you want to constrain nodes from moving in the 90 deg ply. *
C  * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
C
      DIMENSION IND(5),IT(5),INDU(5),ITU(5)
C
C  OPEN AND DEFINE INPUT AND OUTPUT FILES
C
      OPEN(5,FILE='coord4lnc.dat',STATUS='OLD',ERR=888)
      OPEN(6,FILE='coord4lnc.out',STATUS='UNKNOWN',ERR=888)
C
C   Caldculate Scale Factor
C
C     hfactor=1.00000000
      hfactor=12.0000000/1.4000000
C
C      FORMAT STATEMENTS COMMONLY USED
C
   11 FORMAT(2(1X,F7.5),1X,I1,5(1X,I3,1X,I1))
   99 FORMAT(I6,3I3,2F12.6)
C
C      NODE NO.S ARE NUMBERED SEQUENTIALLY
C    ALONG EACH LINE FROM LEFT TO RIGHT WITH
C HORIZONTAL AND VERTICAL COORD GIVEN FOR FIRST NODE
C
C         READ NO OF HORIZONTAL LINES
C
      READ(5,10)NLINES
   10 FORMAT(I3)
C
C       READ FIRST LINE OF NODES
C
      READ(5,11)V,H,NINCR,(IND(INCR),IT(INCR),INCR=1,NINCR)
C
C       LOOP THRUN REMAINING LINES OF NODES
C
      NLP1=NLINES+1
      DO 110 ILINE=2,NLP1
C
C           READ NEXT LINE OF NODES
C
      READ(5,11)VU,HU,NINCRU,(INDU(INCR),ITU(INCR),INCR=1,NINCRU)
C
C   RECOVER FIRST AND LAST NODE NUMBERS OF SET
C
C    LOOP THRU SET OF NODE NUMBER STRINGS
C
      DO 90 INCR=1,NINCR
C
C          RECOVER FIRST AND LAST NODE NUMBERS OF EACH SET
C
      IST=IND(INCR)
      LAST=IND(INCR+1)-1
      IF(INCR.EQ.NINCR)LAST=INDU(1)-1
C
C        CALCULATE HORIZONTAL INCREMENT FOR NODE COORD.
C
      IF(IT(INCR).EQ.0)IT(INCR)=1
      DELH=0.2/(2**(IT(INCR)-1))
C
C        LOOP THRU SET OF NODES GENERATING NODE COORD.S
C
      DO 80 INODE=IST,LAST
      I0=0
      I2=0
      IF(INODE.EQ.441)I0=1
      IF(INODE.GE.441)I2=1
      IQ=0
      IF(H.EQ.0.0)IQ=1
C     IF((V.GT.0.5).AND.(V.LT.1.0))IQ=0
      HW=H*hfactor
      VW=V
      WRITE(6,99)INODE,I0,IQ,I2,HW,VW
      H=H+DELH
   80 CONTINUE
   90 CONTINUE
C
C       SHIFT NODE LINE INFO.
C
      V=VU
      H=HU
      NINCR=NINCRU
      DO 100 INCR=1,NINCRU
      IND(INCR)=INDU(INCR)
      IT(INCR)=ITU(INCR)
  100 CONTINUE
  110 CONTINUE
C
      STOP
  888 END
